<?php
/**
* Joomla Community Builder User Plugin: plug_cbprivacy
* @version $Id$
* @package plug_cbprivacy
* @subpackage cb.privacy.php
* @author Beat
* @copyright (C) 2008-2009 www.joomlapolis.com
* @license Limited http://www.gnu.org/licenses/old-licenses/gpl-2.0.html GNU/GPL version 2
*/

/** ensure this file is being included by a parent file */
if ( ! ( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) { die( 'Direct Access to this location is not allowed.' ); }

global $_PLUGINS;
//$_PLUGINS->registerUserFieldTypes( array( 'helloworldSpecial' => 'CBfield_helloworldSpecial' ) );
$_PLUGINS->registerUserFieldParams();
$_PLUGINS->registerFunction( 'onFieldIcons',						'onFieldIcons',								'CBPrivacy' );
$_PLUGINS->registerFunction( 'onBeforeprepareFieldDataSave',		'onBeforeprepareFieldDataSave',			'CBPrivacy' );
$_PLUGINS->registerFunction( 'onBeforegetFieldRow',				'onBeforegetFieldRow',						'CBPrivacy' );
$_PLUGINS->registerFunction( 'onAfterbindSearchCriteria',			'onAfterbindSearchCriteria',				'CBPrivacy' );
// tabs privacy:
$_PLUGINS->registerUserTabParams();
$_PLUGINS->registerFunction( 'onAfterTabsFetch',					'onAfterTabsFetch',							'getcbprivacyTab' );
$_PLUGINS->registerFunction( 'onAfterEditATab',					'onAfterEditATab',							'getcbprivacyTab' );

class moscomprofilerPrivacy extends comprofilerDBTable {
	var $userid				=	null;
	var $type				=	null;
	var $xid				=	null;
	var $rule				=	null;
	var $params				=	null;
   /**
    * Constructor
    * @param  CBdatabase  $db   A database connector object
    */
	function moscomprofilerPrivacy( &$db ) {
		$this->comprofilerDBTable( '#__comprofiler_privacy', 'userid', $db );
	}
	function load( ) {
		trigger_error( 'moscomprofilerPrivacy::load called !', E_USER_ERROR );
		exit( 1 );
	}
	/**
	 * Gets instance of the moscomprofilerPrivacy object corresponding to user and field
	 * @static
	 *
	 * @param  moscomprofilerUser    $user
	 * @param  string                $type   'field', 'tab'
	 * @param  int                   $xid    id of field or tab
	 * @return moscomprofilerPrivacy
	 */
	function & getInstance( &$user, $type, $xid, $retNull = true ) {
		static $cache									=	array();

		$uid											=	999;
		$xid											=	(int) $xid;

		if ( ! isset( $cache[$uid][$type][$xid] ) ) {
			global $_CB_database;

			if ( $uid && ! isset( $cache[$uid] ) ) {
				$sql									=	'SELECT * FROM ' . $_CB_database->NameQuote( '#__comprofiler_privacy' )
														.	"\n WHERE " . $_CB_database->NameQuote( 'userid' ) . ' = ' . (int) $uid
														.	"\n ORDER BY " . $_CB_database->NameQuote( 'type' ) . ', ' . $_CB_database->NameQuote( 'xid' );
														;
				$_CB_database->setQuery( $sql );
				$cache[$uid]							=	$_CB_database->loadObjectList( array( 'type', 'xid' ), 'moscomprofilerPrivacy', array( &$_CB_database ) );
			}

			if ( ! isset( $cache[$uid][$type][$xid] ) ) {
				if ( $retNull ) {
					$cache[$uid][$type][$xid]			=	null;
				} else {
					$cache[$uid][$type][$xid]			=	new moscomprofilerPrivacy( $_CB_database );
					$cache[$uid][$type][$xid]->userid	=	$uid;
					$cache[$uid][$type][$xid]->type	=	$type;
					$cache[$uid][$type][$xid]->xid		=	$xid;
				}
			}
		}
		return $cache[$uid][$type][$xid];
	}
	/**
	* Inserts a new row
	*
	* @return boolean                TRUE if successful otherwise FALSE
	*/
	function insert( ) {
		$ok					=	$this->_db->insertObject( $this->_tbl, $this, null );

		if ( ! $ok ) {
			$this->_error	=	strtolower(get_class($this))."::store failed: " . $this->_db->getErrorMsg();
		}
		return $ok;
	}
	/**
	* If table key (id) is NULL : inserts a new row
	* otherwise updates existing row in the database table
	*
	* Can be overridden or overloaded by the child class
	*
	* @param  boolean  $updateNulls  TRUE: null object variables are also updated, FALSE: not.
	* @return boolean                TRUE if successful otherwise FALSE
	*/
//	function store( $updateNulls = false ) {
//		if ( ( $this->rule !== null ) || ( $updateNulls ) ) {
//			$sql			=	'UPDATE ' . $this->_db->NameQuote( $this->_tbl )
//							.	' SET '
//							.	$this->_db->NameQuote( 'rule' ) . ' = ' . $this->_db->Quote( $this->rule )
//							.	', '
//							.	$this->_db->NameQuote( 'params' ) . ' = ' . $this->_db->Quote( $this->params )
//							.	"\n WHERE "
//							.	$this->_db->NameQuote( 'userid' ) . ' = ' . $this->_db->Quote( $this->userid )
//							.	"\n AND "
//							.	$this->_db->NameQuote( 'type' ) . ' = ' . $this->_db->Quote( $this->type )
//							.	"\n AND "
//							.	$this->_db->NameQuote( 'xid' ) . ' = ' . $this->_db->Quote( $this->xid )
//							;
//			$this->_db->setQuery( $sql );
//			return $this->_db->query();
//		} else {
//			return true;
//		}
		
//	}
	/**
	* Deletes this record (no checks)
	*
	* @return boolean         TRUE if OK, FALSE if error
	*/
//	function delete( ) {
//		if ( $this->userid && $this->type && $this->xid ) {
//			$query			=	"DELETE FROM "	. $this->_db->NameQuote( $this->_tbl )
//							.	"\n WHERE "		. $this->_db->NameQuote( 'userid' )
//							.	" = "
//							.	(int) $this->userid
//							.	"\n AND "		. $this->_db->NameQuote( 'type' )
//							.	" = "
//							.	(int) $this->type
//							.	"\n AND "		. $this->_db->NameQuote( 'xid' )
//							.	" = "
//							.	(int) $this->xid
//							;
//			$this->_db->setQuery( $query );
//
//			if ($this->_db->query()) {
//				return true;
//			} else {
//				$this->_error	=	$this->_db->getErrorMsg();
//				return false;
//			}
//		}
//		return false;
//	}
	/**
	* Gets a param value
	*
	* @param  string  $key      The name of the param
	* @param  mixed   $default  The default value if not found
	* @return string
	*/
	function getParam( $key, $default = null ) {
		if ( ! is_object( $this->params ) ) {
			$this->params	=	new cbParamsBase( $this->params );
		}
		return $this->params->get( $key, $default );
	}
	/**
	* Sets a value to a param
	*
	* @param  string  $key    The name of the param
	* @param  string  $value  The value of the parameter
	* @return string  The set value
	*/
	function setParam( $key, $value = '' ) {
		if ( ! is_object( $this->params ) ) {
			$this->params	=	new cbParamsBase( $this->params );
		}
		return $this->params->set( $key, $value );
	}
}
class CBPrivacy extends cbFieldHandler {
	/**
	 * Enter description here...
	 *
	 * @param  cbFieldHandler        $fieldHandler
	 * @param  moscomprofilerFields  $field
	 * @param  moscomprofilerUser    $user
	 * @param  string                $output
	 * @param  string                $reason      'profile' for user profile view and edit, 'register' for registration
	 * @param  string                $tag         <tag
	 * @param  string                $type        type="$type"
	 * @param  string                $value       value="$value"
	 * @param  string                $additional  'xxxx="xxx" yy="y"'
	 * @param  string                $allValues
	 * @param  boolean               $displayFieldIcons
	 * @param  boolean               $required
	 * @return string                             HTML
	 */
	function onFieldIcons( &$fieldHandler, &$field, &$user, $output, $reason, $tag, $type, $value, $additional, $allValues, $displayFieldIcons, $required ) {
		global $_CB_framework, $ueConfig, $_CB_fieldIconDisplayed;

		if ( is_object( $field->params ) ) {
			$privacyLevel					=	$field->params->get( 'plug_cbprivacy_level' );
		} else {
			$privacyLevel					=	0;
		}

		if ( $displayFieldIcons && ( $reason != 'search' ) ) {
			if ( ( $privacyLevel == 1 ) && ( $field->profile == 1 ) ) {

				$privacy					=&	moscomprofilerPrivacy::getInstance( $user, 'field', $field->fieldid );
				$selected					=	( $privacy ? $privacy->rule : '' );

				$selectorName				=	$field->name . '___cbprivacy';

				$connTypes					=	array();
				if ( $this->params->get( 'conns_by_type', 0 ) ) {
					if ( $ueConfig['connection_categories'] ) {
						$connTypes			=	explode( "\n", $ueConfig['connection_categories'] );
						foreach ( array_keys( $connTypes ) as $k) {
							$connTypes[$k]	=	trim( $connTypes[$k] );
						}
					}
					if ( $selected == 2 ) {
						$type				=	$privacy->getParam( 'conn_cat' );
						if ( $type ) {
							$selected		=	$selected . '|*|' . $type;
						}
					}
				}

				$options					=	array();
				$options[]					=	moscomprofilerHTML::makeOption( '', '&radic; ' . CBTxt::T('Visible on profile') );
				if ( ( $ueConfig['allow_profileviewbyGID'] == -2 ) && $this->params->get( 'prop_registered', 1 ) ) {
					$options[]				=	moscomprofilerHTML::makeOption( '1', '&harr; ' . CBTxt::T('Only to logged-in users' ) );
				}
				if ( $ueConfig['allowConnections'] ) {
					$prop_connections		=	$this->params->get( 'prop_connections', 1 );
					if ( $prop_connections ) {
						$options[]			=	moscomprofilerHTML::makeOption( '2', '&there4; ' . CBTxt::T( 'Only for direct connections' ) );
					}
					if ( count( $connTypes ) > 1 ) {
						foreach ($connTypes as $type ) {
							$options[]		=	moscomprofilerHTML::makeOption( '2|*|' . htmlspecialchars( $type ), ( $prop_connections ? '&nbsp;&nbsp;&lfloor;&nbsp;' : '' ) . '&there4; ' . sprintf( CBTxt::T( 'Only for %s' ), $type ) );
						}
					}
					if ( $this->params->get( 'prop_fofs', 1 ) ) {
						$options[]			=	moscomprofilerHTML::makeOption( '3', '&hellip; ' . CBTxt::T( 'Also for connections\' connections' ) );
					}
				}
				if ( $this->params->get( 'prop_invisible', 1 ) ) {
					$options[]				=	moscomprofilerHTML::makeOption( '99', '&otimes; ' . CBTxt::T( 'Invisible on profile' ) );
				}
				$selHtml					=	moscomprofilerHTML::selectList( $options, $selectorName, '', 'value', 'text', $selected, 2, false );
				if ( isset( $_CB_fieldIconDisplayed[$field->fieldid] ) ) {
					return $selHtml;
				} else {
					$_CB_fieldIconDisplayed[$field->fieldid]	=	true;
					return $selHtml . '&nbsp;' . getFieldIcons( $_CB_framework->getUi(), $required, null, $fieldHandler->getFieldDescription( $field, $user, $output, $reason ), $fieldHandler->getFieldTitle( $field, $user, $output, $reason ) );
				}
			} else {
				if ( isset( $_CB_fieldIconDisplayed[$field->fieldid] ) ) {
					return null;
				} else {
					$_CB_fieldIconDisplayed[$field->fieldid]	=	true;
					return getFieldIcons( $_CB_framework->getUi(), $required, $field->profile, $fieldHandler->getFieldDescription( $field, $user, $output, $reason ), $fieldHandler->getFieldTitle( $field, $user, $output, $reason ) );
				}
				
			}
			
		} else {
			return null;
		}
	}
	/**
	 * Prepares field data for saving to database (safe transfer from $postdata to $user)
	 * Override
	 *
	 * @param  moscomprofilerFields  $field
	 * @param  moscomprofilerUser    $user      RETURNED populated: touch only variables related to saving this field (also when not validating for showing re-edit)
	 * @param  array                 $postdata  Typically $_POST (but not necessarily), filtering required.
	 * @param  string                $reason    'profile' for save user edit, 'register' for save registration
	 * @return NULL                             //TBD should be True: All fields have validated, False: Some fields didn't validate
	 */
	function onBeforeprepareFieldDataSave ( &$field, &$user, &$postdata, $reason ) {
		if ( is_object( $field->params ) ) {
			$privacyLevel				=	$field->params->get( 'plug_cbprivacy_level' );
		} else {
			$privacyLevel				=	0;
		}

		if ( ( $privacyLevel == 1 ) && ( $field->profile == 1 ) ) {
			global $ueConfig;

			$connTypes					=	array();
			if ( $ueConfig['connection_categories'] ) {
				$connTypes				=	explode( "\n", $ueConfig['connection_categories'] );
				foreach ( array_keys( $connTypes ) as $k) {
					$connTypes[$k]		=	trim( $connTypes[$k] );
				}
			}

			$ruleParams					=	explode( '|*|', stripslashes( cbGetParam( $postdata, $field->name . '___cbprivacy' ) ), 2 );
			$rule						=	(int) $ruleParams[0];
			if ( ( $this->params->get( 'conns_by_type', 0 ) ) && ( $rule == 2 ) && isset( $ruleParams[1] ) && in_array( $ruleParams[1], $connTypes ) ) {
				cbimport( 'cb.params' );
				$paramsText				=	stripslashes( cbParamsEditorController::getRawParams( array( 'conn_cat' => $ruleParams[1] ) ) );
			} else {
				$paramsText				=	'';
			}
			

			$privacy					=&	moscomprofilerPrivacy::getInstance( $user, 'field', $field->fieldid );
			if ( $privacy ) {
				if ( $rule ) {
					$privacy->rule		=	$rule;
					$privacy->params	=	$paramsText;
//					$privacy->store();
				} elseif ( $rule === 0 ) {
//					$privacy->delete();
				}
			} elseif ( $rule ) {
				$privacy				=&	moscomprofilerPrivacy::getInstance( $user, 'field', $field->fieldid, false );
				$privacy->rule			=	$rule;
				$privacy->params		=	$paramsText;
				$privacy->insert();
			}
		}
	}
	/**
	 * Returns a field in specified format
	 *
	 * @param  moscomprofilerFields  $field
	 * @param  moscomprofilerUser    $user
	 * @param  string                $output      'html', 'xml', 'json', 'php', 'csvheader', 'csv', 'rss', 'fieldslist', 'htmledit'
	 * @param  string                $formatting  'table', 'td', 'span', 'div', 'none'
	 * @param  string                $reason      'profile' for user profile view and edit, 'register' for registration
	 * @param  int                   $list_compare_types   IF reason == 'search' : 0 : simple 'is' search, 1 : advanced search with modes, 2 : simple 'any' search
	 * @return mixed
	 */
	function onBeforegetFieldRow( &$field, &$user, $output, $formatting, $reason, $list_compare_types ) {
		$result											=	null;
		if ( is_object( $field->params ) ) {
			$privacyLevel								=	$field->params->get( 'plug_cbprivacy_level' );
		} else {
			$privacyLevel								=	0;
		}

		if ( ( $output == 'htmledit' ) && ( $reason != 'search' ) ) {
			global $_CB_framework;

			if ( ( $_CB_framework->getUi() == 1 ) && ( $reason != 'register' ) ) {
				$privacyEditFE							=	$field->params->get( 'plug_cbprivacy_frontend_edit' );
				switch ($privacyEditFE ) {
					case 2:
						// only by moderators:
						$myId							=	$_CB_framework->myId();
						if ( $myId == 999 ) {
							$result						=	' ';
						}
						break;

					case 1:
						// no front-end edits:
						$result							=	' ';
						break;

					case 0:
					default:
						break;
				}
			}			
		} else {
			global $_CB_framework, $ueConfig;
				
			$myId										=	$_CB_framework->myId();
			if ( ( $privacyLevel == 1 ) && ( $field->profile == 1 ) && ( $myId != $user->id ) ) {
				$privacy								=&	moscomprofilerPrivacy::getInstance( $user, 'field', $field->fieldid );
				if ( $privacy && ( $privacy->rule > 0 ) ) {
					switch ( $privacy->rule ) {
						case 1:		// logged-in users only
						case 2:		// connections only:
						case 3:		// FOFs only:
							// logged-in users only
							if ( $myId == 0 ) {
								if ( $this->params->get( 'show_fields_access_registered_error', 1 ) == 1 ) {
									if ( $output == 'html' ) {
										if ( ! ( ( ( $_CB_framework->getCfg( 'allowUserRegistration' ) == '0' )
											   && ( ( ! isset($ueConfig['reg_admin_allowcbregistration']) ) || $ueConfig['reg_admin_allowcbregistration'] != '1' ) )
											 || $_CB_framework->myId() ) ) {
											$result		=	sprintf( CBTxt::T('Access only to logged-in users. Please login or %s.'), '<a href="' . cbSef( 'index.php?option=com_comprofiler&amp;task=registers' ) . '">' . CBTxt::T('register') . '</a>.' );
										} else {
											$result		=	CBTxt::T('Access only to logged-in users. Please login.');
										}
										
									} else {
										$result			=	CBTxt::T('Access only with login');
									}
								} else {
									$result				=	' ';	// no error message on profile, simply hides field row
								}
							}
	
							if ( $privacy->rule == 1 ) {
								// logged-in users only: stop here:
								break;
							}

							if ( $privacy->rule == 2 ) {
								// connections only:
								$connOK						=	false;
								if ( $myId > 0 ) {
									$cbCon					=	new cbConnection( $myId );
									$directConDetails		=	$cbCon->getConnectionDetails( $user->id, $myId );
									if ( $directConDetails && $directConDetails->accepted != 0 ) {
										if ( $this->params->get( 'conns_by_type', 0 ) ) {
											$connCat		=	$privacy->getParam( 'conn_cat', '' );
											if ( $connCat === '' ) {
												$connOK		=	true;
											} else {
												$realCats	=	explode( '|*|', $directConDetails->type );
												if ( in_array( $connCat, $realCats ) ) {
													$connOK	=	true;
												}
											}
										} else {
											$connOK			=	true;
										}
									}
								}
	
								if ( ! $connOK ) {
									if ( $this->params->get( 'show_fields_access_connection_error', 1 ) == 1 ) {
										$result				=	CBTxt::T('Access only to directly connected users');
	/*	//TBD later, as this is not correct, it's the reverse connection which must be made, and accepted! too many cases to handle this in first version...:
										if ( ( $output == 'html' ) && ( $myId > 0 ) ) {
											if ( $directConDetails === false ) {
												$result	.=	': <a href="' . cbSef( 'index.php?option=com_comprofiler&amp;task=connectRequest&amp;user=' . (int) $user->id ) . '">request connection</a>.';		//TBD: implement task...
											}
										}
	*/
									} else {
										$result				=	' ';	// no error message on profile, simply hides field row
									}
								}
							} elseif ( $privacy->rule == 3 ) {
								// FOFs only:
								$connOK						=	false;
								if ( $myId > 0 ) {
									$cbCon					=	new cbConnection( $myId );
									$directConDetails		=	$cbCon->getDegreeOfSepPathArray( $user->id, $myId, 1, 2 );
									if ( ! empty( $directConDetails ) ) {
										$connOK				=	true;
									}
								}
								if ( ! $connOK ) {
									if ( $this->params->get( 'show_fields_access_connection_error', 1 ) == 1 ) {
										$result				=	CBTxt::T('Access only to directly connected users and friends of friends');
	/*	//TBD later, as this is not correct, it's the reverse connection which must be made, and accepted! too many cases to handle this in first version...:
										if ( ( $output == 'html' ) && ( $myId > 0 ) ) {
											if ( $directConDetails === false ) {
												$result	.=	': <a href="' . cbSef( 'index.php?option=com_comprofiler&amp;task=connectRequest&amp;user=' . (int) $user->id ) . '">request connection</a>.';		//TBD: implement task...
											}
										}
	*/
									} else {
										$result				=	' ';	// no error message on profile, simply hides field row
									}
								}
							}
							break;

						case 99:
						default:
							// invisible on profile:
							$result							=	' ';
							break;
							;
						break;
					}
				}
			}
		}
		if ( trim( $result ) !== '' ) {
			$fieldName									=	$field->name;
			$saveValue									=	$user->get( $fieldName );
			$user->$fieldName							=	$result;
			$result										=	parent::getFieldRow( $field, $user, $output, $formatting, $reason, $list_compare_types );
			$user->$fieldName							=	$saveValue;
		}
		return $result;
	}
	/**
	 * Accessor:
	 * Returns a field in specified format
	 *
	 * @param  moscomprofilerFields  $field
	 * @param  moscomprofilerUser    $user
	 * @param  string                $output  'html', 'xml', 'json', 'php', 'csvheader', 'csv', 'rss', 'fieldslist', 'htmledit'
	 * @param  string                $reason  'profile' for user profile view and edit, 'register' for registration, 'list' for user-lists
	 * @param  int                   $list_compare_types   IF reason == 'search' : 0 : simple 'is' search, 1 : advanced search with modes, 2 : simple 'any' search
	 * @return mixed
	 */
	function getField( &$field, &$user, $output, $reason, $list_compare_types ) {
		$value								=	$user->get( $field->name );
		return $this->_formatFieldOutput( $field->name, $value, $output, false );
	}
	/**
	 * Finder:
	 * Prepares field data for saving to database (safe transfer from $postdata to $user)
	 * Override
	 *
	 * @param  moscomprofilerFields  $field
	 * @param  moscomprofilerUser    $searchVals  RETURNED populated: touch only variables related to saving this field (also when not validating for showing re-edit)
	 * @param  array                 $postdata    Typically $_POST (but not necessarily), filtering required.
	 * @param  int                   $list_compare_types   IF reason == 'search' : 0 : simple 'is' search, 1 : advanced search with modes, 2 : simple 'any' search
	 * @param  string                $reason      'profile' for save user edit, 'register' for save registration
	 * @return array of cbSqlQueryPart
	 */
	function onAfterbindSearchCriteria( &$field, &$searchVals, &$postdata, $list_compare_types, $reason, &$query ) {
		//TBD:
		//	<column name="enabled" operator="=" value="1" type="sql:field" valuetype="const:int">
		//		<data  name="enabled" type="sql:field" table="#__comprofiler_tabs" class="moscomprofilerTab" key="tabid" value="tabid" valuetype="sql:field" />
/*
<column name="id"     operator="=" value="user_id" type="int"       valuetype="sql:formula">
	<data name="user_id" type="sql:field" table="#__cpay_payment_baskets" class="cbpaidPayementBasket" key="user_id" value="id" valuetype="sql:field">
		<where>
			<column name="payment_status" operator="=" value="Completed" type="sql:field" valuetype="const:string" />
		</where>
	</data>
</column>
<data name="" type="sql:function" operator="IF">
	<data name="" type="sql:function" operator="ISNULL">
		<data name="ordering" type="sql:field" table="#__cpay_plans" class="cbpaidPlansMgr::productObjects" key="id" value="parent" />
	</data>
	<data name="ordering" type="sql:field" />
	<data name="ordering" type="sql:field" table="#__cpay_plans" class="cbpaidPlansMgr::productObjects" key="id" value="parent" />
</data>

<data name="change_logs" type="sql:count" distinct="id"  table="#__cpay_history" class="cbpaidHistory">
	<joinkeys dogroupby="true">
		<column name="table_name"   operator="=" value="#__cpay_plans" type="sql:field" valuetype="const:string" />
		<column name="table_key_id" operator="=" value="id" type="sql:field" valuetype="sql:field" />
	</joinkeys>
</data>

SELECT ue.*, u.*, '' AS 'NA' FROM jos_comprofiler ue, jos_users u
 LEFT JOIN jos_comprofiler_privacy AS p ON ( p.userid = u.id AND p.fieldid = 30)
 LEFT JOIN jos_comprofiler_privacy AS q ON ( q.userid = u.id AND q.fieldid = 31)
 WHERE u.block = 0
 AND ue.approved = 1
 AND ue.confirmed = 1
 AND u.`id` = ue.`id`

 AND ISNULL( p.rule )
 AND ISNULL( q.rule )

 ORDER BY `username` ASC
 LIMIT 0, 5

<column name="fieldname" table="#__comprofiler" type="sql:field" operator="=" value="val" valuetype="const:inst" searchmode="searchmode" />

<column name="func" type="sql:function" operator="ISNULL">
	<data name="rule" type="sql:field" table="#__comprofiler_privacy" class="moscomprofilerPrivacy">
		<joinkeys dogroupby="false" operator="AND">
			<column name="userid" operator="=" value="id" type="sql:field" valuetype="sql:field" />
			<column name="fieldid" operator="=" value="123" type="sql:field" valuetype="const:int" />
		</joinkeys>
	<data>
</column>


*/
		static $tabsAlreadyChecked		=	array();

		if ( count( $query ) > 0 ) {
			if ( is_object( $field->params ) ) {
				$privacyLevel						=	$field->params->get( 'plug_cbprivacy_level' );
				$privacyNoSearch					=	$field->params->get( 'plug_cbprivacy_nosearch', 1 );
			} else {
				$privacyLevel						=	0;
				$privacyNoSearch					=	0;
			}
			if ( ( $privacyLevel == 1 ) && ( $field->profile == 1 ) && ( $privacyNoSearch != 0 ) ) {
				// that field can have privacy levels set by users: we need to search only for users which didn't set a particular privacy level:
				$query[]							=	$this->_cbSqlPrivacyQuery( 'isnotprivatefield_' . $field->name, $field->fieldid, 'field' );
			}

			$tab									=&	$this->_getTab( $field->tabid );
			$privacyLevelTab						=	$tab->params->get( 'plug_cbprivacy_tab_level' );
			if ( $privacyLevelTab && ! isset( $tabsAlreadyChecked[$field->tabid] ) ) {
				$query[]							=	$this->_cbSqlPrivacyQuery( 'isnotprivatetab_' . $field->tabid, $field->tabid, 'tab' );
			}
		
		}
	}
	function _cbSqlPrivacyQuery( $joinName, $xid, $type ) {
		$sql					=	new cbSqlQueryPart();
		$sql->tag				=	'column';
		$sql->name				=	$joinName;
		$sql->type				=	'sql:function';
		$sql->operator			=	'ISNULL';

		$data					=	new cbSqlQueryPart();
		$data->tag				=	'data';
		$data->name				=	'rule';
		$data->table			=	'#__comprofiler_privacy';
		$data->type				=	'sql:field';

		$joinkeys				=	new cbSqlQueryPart();
		$joinkeys->tag			=	'joinkeys';
		$joinkeys->operator		=	'AND';
		//$joinkeys->dogroupby	=	'false';

		$colA					=	new cbSqlQueryPart();
		$colA->tag				=	'column';
		$colA->name				=	'userid';
		$colA->table			=	'#__comprofiler_privacy';
		$colA->operator			=	'=';
		$colA->value			=	'id';
		$colA->type				=	'sql:field';
		$colA->valuetype		=	'sql:field';

		$colB					=	new cbSqlQueryPart();
		$colB->tag				=	'column';
		$colB->name				=	'xid';
		$colB->table			=	'#__comprofiler_privacy';
		$colB->operator			=	'=';
		$colB->value			=	(int) $xid;
		$colB->type				=	'sql:field';
		$colB->valuetype		=	'const:int';

		$colC					=	new cbSqlQueryPart();
		$colC->tag				=	'column';
		$colC->name				=	'type';
		$colC->table			=	'#__comprofiler_privacy';
		$colC->operator			=	'=';
		$colC->value			=	$type;
		$colC->type				=	'sql:field';
		$colC->valuetype		=	'const:string';

		$joinkeys->addChildren( array( $colA, $colB, $colC ) );
		$data->addChildren( array( $joinkeys ) );
		$sql->addChildren( 	array( $data ) );
		return $sql;
	}
	/**
	 * Returns the tab object corresponding to a tab id.
	 * Tab must be enabled and accessible to the my user.
	 * This function is temporary until we rework the tabs manager:		//TBD to be improved when tabs manager is redone.
	 *
	 * @param  int                 $tabid
	 * @return moscomprofilerTabs
	 */
	function & _getTab( $tabid ) {
		global $_CB_framework, $_CB_database;

		static $cache			=	null;

		$tabid					=	(int) $tabid;
		if ( ! isset( $cache ) ) {
			// do exactly same SQL query as in _loadTabsList for now to use the SQL caching:
			$_CB_database->setQuery( "SELECT * FROM #__comprofiler_tabs t"
			. "\n WHERE t.enabled=1"
			. "\n AND t.useraccessgroupid IN (".implode(',',getChildGIDS(userGID( $_CB_framework->myId() ))).")"
			. "\n ORDER BY t.position, t.ordering" );
			$cache				=	$_CB_database->loadObjectList( 'tabid', 'moscomprofilerTabs', array( &$_CB_database ) );
		}
		if ( isset( $cache[$tabid] ) ) {
			if ( ! is_object( $cache[$tabid]->params ) ) {
				$cache[$tabid]->params				=	new cbParamsBase( $cache[$tabid]->params );
			}
			return $cache[$tabid];
		} else {
			$null				=	null;
			return $null;
		}
	}
}

class getcbprivacyTab extends cbTabHandler {
	/**
	 * Called after tabs rendering called but before returning the rendering
	 *
	 * @param  array               $tabs
	 * @param  moscomprofilerUser  $user
	 * @param  string              $reason  ( 'profile', 'register', 'list', 'edit', 'editsave' )
	 */
	function onAfterTabsFetch( &$tabs, &$user, $reason ) {
		global $_CB_framework, $ueConfig;

		$output													=	'html';		//TBD temp.
		$myId													=	$_CB_framework->myId();
		if ( $user && ( $user->id > 0 ) && ( $myId != $user->id ) && ( $reason != 'edit' ) && ( $reason != 'editsave' ) ) {

			foreach ( $tabs as $k => $t ) {
				if ( is_object( $t->params ) ) {
					$privacyLevel								=	$t->params->get( 'plug_cbprivacy_tab_level' );
				} else {
					$params										=	new cbParamsBase( $t->params );
					$privacyLevel								=	$params->get( 'plug_cbprivacy_tab_level' );
				}
				if ( $privacyLevel ) {
					$privacy									=&	moscomprofilerPrivacy::getInstance( $user, 'tab', $t->tabid );
					if ( $privacy && ( $privacy->rule > 0 ) ) {
						$result									=	null;
						switch ( $privacy->rule ) {
							case 1:		// logged-in users only
							case 2:		// connections only:
							case 3:		// FOFs only:
								// logged-in users only
								if ( $myId == 0 ) {
									if ( $this->params->get( 'show_tabs_access_registered_error', 1 ) == 1 ) {
										if ( $output == 'html' ) {
											if ( ! ( ( ( $_CB_framework->getCfg( 'allowUserRegistration' ) == '0' )
												   && ( ( ! isset($ueConfig['reg_admin_allowcbregistration']) ) || $ueConfig['reg_admin_allowcbregistration'] != '1' ) )
												 || $_CB_framework->myId() ) ) {
													$result		=	sprintf( CBTxt::T('Access only to logged-in users. Please login or %s.'), '<a href="' . cbSef( 'index.php?option=com_comprofiler&amp;task=registers' ) . '">' . CBTxt::T('register') . '</a>.' );
											} else {
												$result			=	CBTxt::T('Access only to logged-in users. Please login.');
											}
											
										} else {
											$result				=	CBTxt::T('Access only with login');
										}
									} else {
										$result					=	' ';	// no error message on profile, simply hides field row
									}
								}
		
								if ( $privacy->rule == 1 ) {
									// logged-in users only: stop here:
									break;
								}
								if ( $privacy->rule == 2 ) {
									// connections only:
									$connOK						=	false;
									if ( $myId > 0 ) {
										$cbCon					=	new cbConnection( $myId );
										$directConDetails		=	$cbCon->getConnectionDetails( $user->id, $myId );
										if ( $directConDetails && $directConDetails->accepted != 0 ) {
											if ( $this->params->get( 'conns_by_type', 0 ) ) {
												$connCat		=	$privacy->getParam( 'conn_cat', '' );
												if ( $connCat === '' ) {
													$connOK		=	true;
												} else {
													$realCats	=	explode( '|*|', $directConDetails->type );
													if ( in_array( $connCat, $realCats ) ) {
														$connOK	=	true;
													}
												}
											} else {
												$connOK			=	true;
											}
										}										
									}
									
									if ( ! $connOK ) {
										if ( $this->params->get( 'show_tabs_access_connection_error', 1 ) == 1 ) {
											$result				=	CBTxt::T('Access only to directly connected users');
		/*	//TBD later, as this is not correct, it's the reverse connection which must be made, and accepted! too many cases to handle this in first version...:
											if ( ( $output == 'html' ) && ( $myId > 0 ) ) {
												if ( $directConDetails === false ) {
													$result	.=	': <a href="' . cbSef( 'index.php?option=com_comprofiler&amp;task=connectRequest&amp;user=' . (int) $user->id ) . '">request connection</a>.';		//TBD: implement task...
												}
											}
		*/
										} else {
											$result				=	' ';	// no error message on profile, simply hides field row
										}
									}
								} elseif ( $privacy->rule == 3 ) {
									// FOFs only:
									$connOK						=	false;
									if ( $myId > 0 ) {
										$cbCon					=	new cbConnection( $myId );
										$directConDetails		=	$cbCon->getDegreeOfSepPathArray( $user->id, $myId, 1, 2 );
										if ( ! empty( $directConDetails ) ) {
											$connOK				=	true;
										}
									}
									if ( ! $connOK ) {
										if ( $this->params->get( 'show_tabs_access_connection_error', 1 ) == 1 ) {
											$result				=	CBTxt::T('Access only to directly connected users and friends of friends');
		/*	//TBD later, as this is not correct, it's the reverse connection which must be made, and accepted! too many cases to handle this in first version...:
											if ( ( $output == 'html' ) && ( $myId > 0 ) ) {
												if ( $directConDetails === false ) {
													$result	.=	': <a href="' . cbSef( 'index.php?option=com_comprofiler&amp;task=connectRequest&amp;user=' . (int) $user->id ) . '">request connection</a>.';		//TBD: implement task...
												}
											}
		*/
										} else {
											$result				=	' ';	// no error message on profile, simply hides field row
										}
									}
								}
								break;
		
							case 99:
							default:
								// invisible on profile:
								$result							=	' ';
								break;
								;
							break;
						}

						if ( $result !== null ) {
							unset( $tabs[$k] );
						}
					}
				}
			}
		}

		if ( ( $reason == 'editsave' ) && ( $user->id ) ) {
			global $_POST;

			foreach ( $tabs as $k => $t ) {
				if ( is_object( $t->params ) ) {
					$privacyLevel							=	$t->params->get( 'plug_cbprivacy_tab_level' );
				} else {
					$params									=	new cbParamsBase( $t->params );
					$privacyLevel							=	$params->get( 'plug_cbprivacy_tab_level' );
				}
				if ( $privacyLevel ) {
					global $ueConfig;
		
					$connTypes								=	array();
					if ( $ueConfig['connection_categories'] ) {
						$connTypes							=	explode( "\n", $ueConfig['connection_categories'] );
						foreach ( array_keys( $connTypes ) as $k) {
							$connTypes[$k]					=	trim( $connTypes[$k] );
						}
					}

					$privacy								=&	moscomprofilerPrivacy::getInstance( $user, 'tab', $t->tabid );
					$selectorName							=	'cbprivacy_tab_' . $t->tabid;

					$ruleParams								=	explode( '|*|', stripslashes( cbGetParam( $_POST, $selectorName ) ), 2 );
					$rule									=	(int) $ruleParams[0];
					if ( ( $this->params->get( 'conns_by_type', 0 ) ) && ( $rule == 2 ) && isset( $ruleParams[1] ) && in_array( $ruleParams[1], $connTypes ) ) {
						cbimport( 'cb.params' );
						$paramsText							=	stripslashes( cbParamsEditorController::getRawParams( array( 'conn_cat' => $ruleParams[1] ) ) );
					} else {
						$paramsText							=	'';
					}

					if ( $privacy ) {
						if ( $rule ) {
							$privacy->rule					=	$rule;
							$privacy->params				=	$paramsText;
//							$privacy->store();
						} elseif ( $rule === 0 ) {
//							$privacy->delete();
						}
					} elseif ( $rule ) {
						$privacy							=&	moscomprofilerPrivacy::getInstance( $user, 'tab', $t->tabid, false );
						$privacy->rule						=	$rule;
						$privacy->params					=	$paramsText;
						$privacy->insert();
					}

				}
			}
		}
	}
	/**
	 * Called after a tabbed tab is rendered
	 *
	 * @param  string              $content
	 * @param  moscomprofilerTabs  $tab
	 * @param  moscomprofilerUser  $user
	 * @param  array               $postdata
	 * @param  string              $output
	 * @param  string              $formatting
	 * @param  string              $reason
	 * @param  boolean             $tabbed
	 */
	function onAfterEditATab( &$content, &$tab, &$user, &$postdata, $output, $formatting, $reason, $tabbed ) {
		if ( $content ) {
			global $ueConfig;
	
			if ( is_object( $tab->params ) ) {
				$privacyLevel				=	$tab->params->get( 'plug_cbprivacy_tab_level' );
			} else {
				$params						=	new cbParamsBase( $tab->params );
				$privacyLevel				=	$params->get( 'plug_cbprivacy_tab_level' );
			}
	
			if ( $privacyLevel == 1 ) {

				$privacy					=&	moscomprofilerPrivacy::getInstance( $user, 'tab', $tab->tabid );
				$selected					=	( $privacy ? $privacy->rule : '' );

				$selectorName				=	'cbprivacy_tab_' . $tab->tabid;

				$connTypes					=	array();
				if ( $this->params->get( 'conns_by_type', 0 ) ) {
					if ( $ueConfig['connection_categories'] ) {
						$connTypes			=	explode( "\n", $ueConfig['connection_categories'] );
						foreach ( array_keys( $connTypes ) as $k) {
							$connTypes[$k]	=	trim( $connTypes[$k] );
						}
						
					}
					if ( $selected == 2 ) {
						$type				=	$privacy->getParam( 'conn_cat' );
						if ( $type ) {
							$selected		=	$selected . '|*|' . $type;
						}
					}
				}

				$options					=	array();
				$options[]					=	moscomprofilerHTML::makeOption( '', '&radic; ' . CBTxt::T('Visible on profile') );
				if ( ( $ueConfig['allow_profileviewbyGID'] == -2 ) && $this->params->get( 'prop_registered', 1 ) ) {
					$options[]				=	moscomprofilerHTML::makeOption( '1', '&harr; ' . CBTxt::T('Only to logged-in users') );
				}
				if ( $ueConfig['allowConnections'] ) {
					$prop_connections		=	$this->params->get( 'prop_connections', 1 );
					if ( $prop_connections ) {
						$options[]			=	moscomprofilerHTML::makeOption( '2', '&there4; ' . CBTxt::T('Only for direct connections') );
					}
					if ( count( $connTypes ) > 1 ) {
						foreach ($connTypes as $type ) {
							$options[]		=	moscomprofilerHTML::makeOption( '2|*|' . htmlspecialchars( $type ), ( $prop_connections ? '&nbsp;&nbsp;&nbsp;&nbsp;&lfloor; ' : '' ) . '&there4; ' . sprintf( CBTxt::T('Only for %s'), $type ) );
						}
					}
					if ( $this->params->get( 'prop_fofs', 1 ) ) {
						$options[]			=	moscomprofilerHTML::makeOption( '3', '&hellip; ' . CBTxt::T('Also for connections\' connections') );
					}
				}
				if ( $this->params->get( 'prop_invisible', 1 ) ) {
					$options[]				=	moscomprofilerHTML::makeOption( '99', '&otimes; ' . CBTxt::T('Invisible on profile') );
				}
				$selHtml					=	moscomprofilerHTML::selectList( $options, $selectorName, '', 'value', 'text', $selected, 2, false );

				$content					=	'<div class="cbSideSetting cbPrivacyTabSetting">' . $selHtml . '</div>' . $content;
			}
		}
	}
}

?>
